com.microfocus.awm.model

## Interface IElementListDirectory

- All Known Implementing Classes:
    ElementListDirectory

      public interface IElementListDirectory

  Manages all `IElementList`s of an AWM application.

  The singleton instance can be acquired with `TaurusFactory.getElementListDirectory()`.

- - ### Method Summary

    All Methods Instance Methods Abstract Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addElementListDependency(IElementList pList, IElementList pPreviousList)` Add an element list id to the map which contains the sequential dependency between element lists.
    `void` | `addElementListEntries(IElementList pElementList, java.util.List<IElementListEntry> pElementListEntries, boolean pRefreshList)` Add the given element list entry list to the given element list at the given position.
    `void` | `addElementListEntry(IElementList pElementList, IElementListEntry pElementListEntry, boolean pRefresh)` Deprecated. Element list entries are now being automatically added to their element list during initialization.
    `void` | `addElementListEntry(IElementList pElementList, IElementListEntry pElementListEntry, int index, boolean pRefresh)` Deprecated. Element list entries are now being automatically added to their element list during initialization.
    `void` | `addList(IElementList pElementList, java.lang.String pPrevListID, boolean pNotify)` Add a new element list to the element list map and maintain the related internal data structures.
    `void` | `addList(IElementList pElementList, java.lang.String pPrevListID, java.lang.String pTableViewSecondaryId, boolean pNotify)` Add a new element list to the element list map and table view secondary id map and maintain the related internal data structures.
    `void` | `addObserver(java.util.Observer pObserver)` Add the given observer to this class.
    `void` | `addResourceActionList(ActionDescriptor pAction, IResource pResource, java.lang.String pElementListID)` Deprecated.
    `boolean` | `containsKey(IElementListKey pKey)` Check of the element list directory contains the given logical element list key.
    `void` | `deleteElementLists()` Delete all li_....xml files belonging to the active application from the workspace.
    `void` | `deleteObserver(java.util.Observer pObserver)` Delete the given observer for this class.
    `boolean` | `elementListExists(IElementListKey pKey)` Check if the element list to the given logical key exists physically.
    `IElementListKey` | `getElementListKey(java.lang.String pElementlistID)` Get the key under which the given element list id is stored in the element list directory.
    `java.util.List<IElementList>` | `getElementLists()` Gets a list of all `IElementList`.
    `java.util.List<IElementList>` | `getElementLists(IResource pResource)` Gets element lists which were created with the given resource.
    `java.lang.String` | `getFirstListID()` Get the id of the first element list in the element list directory.
    `java.lang.String` | `getLastListID()` Get the id of the last element list in the element list directory.
    `IElementList` | `getList(IElementListKey pKey)` Returns the element list for the given logical element list key.
    `IElementList` | `getList(java.lang.String pElementListID)` Gets the element list with the given ID.
    `IElementList` | `getNextList(IElementList pEleList)` Gets the element list which follows the given element list.
    `java.lang.String` | `getNextListID(java.lang.String pElementListID)` Deprecated. use `getNextList(IElementList)` instead.
    `IElementList` | `getPreviousList(IElementList pEleList)` Gets the element list which precedes the given element list.
    `java.lang.String` | `getPreviousListID(java.lang.String pElementListID)` Deprecated. use `getPreviousList(IElementList)` instead.
    `IResource` | `getResource(java.lang.String pElementListID)` Get the resource to which the element list with given id is associated.
    `IElementList` | `getSelectedList()` Gets the element list which is currently selected in a table view.
    `IElementList` | `loadElementList(java.lang.String pElementListID)` Load the element list belonging to the given element list id from the workspace.
    `void` | `loadElementListDependency()` Load the lm_elementlists.xml-file from the workspace containing the sequential dependencies between the element lists.
    `void` | `notifyObservers(TaurusNotification pTaurusNotification)` Triggers a notification event for all observers.
    `void` | `notifyRefresh()` Deprecated. does not refresh the tree view.
    `void` | `removeElementListEntries(IElementList pElementList, java.util.List<IElementListEntry> pElementListEntries, boolean pRefreshList)` Deprecated. To delete an element list entry from a list, simply call `IResource.delete()`
    `void` | `removeElementListEntry(IElementList pElementList, IElementListEntry pElementListEntry, boolean pRefreshList)` Deprecated. To delete an element list entry from a list, simply call `IResource.delete()`
    `void` | `removeList(IElementList pElementList)` Removes the given element list from the element list directory.
    `void` | `removeLists(IResource pResource)` Remove all element lists belonging to the given TAURUS resource.
    `IElementList` | `restoreList(ActionDescriptor pAct, IResource pRes)` Tries to restore a Element List for the given parameters.
    `void` | `saveElementList(IElementList pElementList)` Save the li_....xml file for the given element list id to the workspace.
    `void` | `saveElementListDependency()` Save the lm_elementlists.xml-file to the workspace containing the sequential dependencies between the element lists.
    `void` | `saveElementLists()` Save all element lists of the element list directory to the workspace.
    `void` | `setSelectedListID(java.lang.String pElementListID)` Sets the ID of the element list which is (or should be) selected in the main table view.
    `void` | `showList(IElementList pEleList)` Notify the observers of the element list directory of a change in the element list with the given element list id.
    `void` | `showList(IElementList pElementList, java.lang.String pTableViewSecondaryId)` Show the given element list in the table view with given secondary id.

- - ### Method Detail

    - #### addList

          void addList(IElementList pElementList,
                       java.lang.String pPrevListID,
                       boolean pNotify)
                throws TaurusCoreException

      Add a new element list to the element list map and maintain the related internal data structures.
      Parameters:
        `pElementList` - element list to be added to the TAURUS element list directory
        `pPrevListID` - element list which precedes this element list in the element list directory; maybe null, in this case the element list is added to the end of the element list directory
        `pNotify` - flag which determines whether the observers of the element list directory are notified
      Throws:
        `TaurusCoreException` - if the element list could not be recovered

    - #### removeList

          void removeList(IElementList pElementList)

      Removes the given element list from the element list directory.
      Parameters:
        `pElementList` - element list to be removed

    - #### removeLists

          void removeLists(IResource pResource)

      Remove all element lists belonging to the given TAURUS resource.
      Parameters:
        `pResource` - TAURUS resource for which the element list are to be deleted

    - #### addElementListDependency

          void addElementListDependency(IElementList pList,
                                        IElementList pPreviousList)

      Add an element list id to the map which contains the sequential dependency between element lists.
      Parameters:
        `pList` - element list to be added
        `pPreviousList` - element list which precedes the element list id to be added; can be `null`, in this case the element list id is added at the end of the dependency map

    - #### addResourceActionList

          @Deprecated
          void addResourceActionList(ActionDescriptor pAction,
                                                  IResource pResource,
                                                  java.lang.String pElementListID)

      Deprecated.
      Add the given element list id to the map with the key of the given action id and resource id.
      Parameters:
        `pAction` - action of the map's key
        `pResource` - resource of the map's key
        `pElementListID` - element list to be added

    - #### setSelectedListID

          void setSelectedListID(java.lang.String pElementListID)

      Sets the ID of the element list which is (or should be) selected in the main table view.
      Parameters:
        `pElementListID` - the ID of the selected element list

    - #### getList

          IElementList getList(java.lang.String pElementListID)

      Gets the element list with the given ID.
      Parameters:
        `pElementListID` - the element list ID
      Returns:
        the element list or `null`

    - #### getResource

          IResource getResource(java.lang.String pElementListID)

      Get the resource to which the element list with given id is associated.
      Parameters:
        `pElementListID` - the element list's id
      Returns:
        TAURUS resource to which the element list with the given id is associated

    - #### getElementListKey

          IElementListKey getElementListKey(java.lang.String pElementlistID)

      Get the key under which the given element list id is stored in the element list directory.
      Parameters:
        `pElementlistID` - the element list's id
      Returns:
        key under which the given element list id is stored in the element list directory

    - #### containsKey

          boolean containsKey(IElementListKey pKey)

      Check of the element list directory contains the given logical element list key.
      Parameters:
        `pKey` - logical element list key
      Returns:
        `true`, if the element list directory contains the given key, otherwise `false`

    - #### elementListExists

          boolean elementListExists(IElementListKey pKey)

      Check if the element list to the given logical key exists physically.
      Parameters:
        `pKey` - logical element list key
      Returns:
        `true`, if the element list exists physically, otherwise `false`

    - #### getPreviousListID

          @Deprecated
          java.lang.String getPreviousListID(java.lang.String pElementListID)

      Deprecated. use `getPreviousList(IElementList)` instead.
      Get the element list id which precedes the given element list id.
      Parameters:
        `pElementListID` - element list id
      Returns:
        element list id which precedes the given element list id; `null`, if the element list id is the first id in the element list directory

    - #### getNextListID

          @Deprecated
          java.lang.String getNextListID(java.lang.String pElementListID)

      Deprecated. use `getNextList(IElementList)` instead.
      Get the element list id which follows the given element list id.
      Parameters:
        `pElementListID` - element list id
      Returns:
        element list id which follows the given element list id; `null`, if the element list id is the last id in the element list directory

    - #### getFirstListID

          java.lang.String getFirstListID()

      Get the id of the first element list in the element list directory.
      Returns:
        id of the first element list in the element list directory

    - #### getLastListID

          java.lang.String getLastListID()

      Get the id of the last element list in the element list directory.
      Returns:
        id of the last element list in the element list directory

    - #### addElementListEntry

          @Deprecated
          void addElementListEntry(IElementList pElementList,
                                                IElementListEntry pElementListEntry,
                                                boolean pRefresh)

      Deprecated. Element list entries are now being automatically added to their element list during initialization.
      Add the given element list entry to the given element list.
      Parameters:
        `pElementList` - element list
        `pElementListEntry` - element list entry
        `pRefresh` - `true`, if the observers of the element list directory should be notified for a refresh; otherwise `false`

    - #### addElementListEntry

          @Deprecated
          void addElementListEntry(IElementList pElementList,
                                                IElementListEntry pElementListEntry,
                                                int index,
                                                boolean pRefresh)

      Deprecated. Element list entries are now being automatically added to their element list during initialization.
      Add the given element list entry to the given element list at the given position.
      Parameters:
        `pElementList` - element list
        `pElementListEntry` - element list entry
        `index` - position in the element list at which the element list entry should be added
        `pRefresh` - `true`, if the observers of the element list directory should be notified for a refresh; otherwise `false`

    - #### removeElementListEntry

          @Deprecated
          void removeElementListEntry(IElementList pElementList,
                                                   IElementListEntry pElementListEntry,
                                                   boolean pRefreshList)
                                            throws TaurusCoreException

      Deprecated. To delete an element list entry from a list, simply call `IResource.delete()`
      Remove the given element list entry from the given element list.
      Parameters:
        `pElementList` - element list
        `pElementListEntry` - element list entry
        `pRefreshList` - `true`, if the observers of the element list directory should be notified for a refresh; otherwise `false`
      Throws:
        `TaurusCoreException` - if the deletion fails

    - #### addElementListEntries

          void addElementListEntries(IElementList pElementList,
                                     java.util.List<IElementListEntry> pElementListEntries,
                                     boolean pRefreshList)

      Add the given element list entry list to the given element list at the given position.
      Parameters:
        `pElementList` - element list
        `pElementListEntries` - list of element list entries
        `pRefreshList` - `true`, if the observers of the element list directory should be notified for a refresh; otherwise `false`

    - #### removeElementListEntries

          @Deprecated
          void removeElementListEntries(IElementList pElementList,
                                                     java.util.List<IElementListEntry> pElementListEntries,
                                                     boolean pRefreshList)

      Deprecated. To delete an element list entry from a list, simply call `IResource.delete()`
      Remove the given element list entry list from the given element list.
      Parameters:
        `pElementList` - element list
        `pElementListEntries` - list of element list entries
        `pRefreshList` - `true`, if the observers of the element list directory should be notified for a refresh; otherwise `false`

    - #### showList

          void showList(IElementList pEleList)

      Notify the observers of the element list directory of a change in the element list with the given element list id.
      Parameters:
        `pEleList` - the `ElementList`

    - #### restoreList

          IElementList restoreList(ActionDescriptor pAct,
                                   IResource pRes)

      Tries to restore a Element List for the given parameters. Does not create a new Element List if none exists (`null` will be returned in that case).
      Parameters:
        `pAct` - the `ActionDescriptor` which creates the Element List
        `pRes` - the parent `IResource` of the Element List
      Returns:
        the cached element list or `null` if the element list didn't exist in the cache
      See Also:
        `IElementListKey`

    - #### addObserver

          void addObserver(java.util.Observer pObserver)

      Add the given observer to this class.
      Parameters:
        `pObserver` - observer

    - #### deleteObserver

          void deleteObserver(java.util.Observer pObserver)

      Delete the given observer for this class.
      Parameters:
        `pObserver` - observer

    - #### getSelectedList

          IElementList getSelectedList()

      Gets the element list which is currently selected in a table view.
      Returns:
        the selected element list or `null`

    - #### saveElementList

          void saveElementList(IElementList pElementList)
                        throws TaurusCoreException

      Save the li_....xml file for the given element list id to the workspace.
      Parameters:
        `pElementList` - element list
      Throws:
        `TaurusCoreException` - if saving the element lists into cache fails

    - #### saveElementLists

          void saveElementLists()
                         throws TaurusCoreException

      Save all element lists of the element list directory to the workspace.
      Throws:
        `TaurusCoreException` - if saving the element lists fails

    - #### loadElementList

          IElementList loadElementList(java.lang.String pElementListID)
                                throws TaurusCoreException

      Load the element list belonging to the given element list id from the workspace.
      Parameters:
        `pElementListID` - id of the element list
      Returns:
        the element list with the given ID or `null`
      Throws:
        `TaurusCoreException` - if loading the element lists fails

    - #### saveElementListDependency

          void saveElementListDependency()
                                  throws TaurusCoreException

      Save the lm_elementlists.xml-file to the workspace containing the sequential dependencies between the element lists.
      Throws:
        `TaurusCoreException` - if saving the element list dependencies fails

    - #### loadElementListDependency

          void loadElementListDependency()
                                  throws TaurusCoreException

      Load the lm_elementlists.xml-file from the workspace containing the sequential dependencies between the element lists.
      Throws:
        `TaurusCoreException` - if loading the element list dependencies fails

    - #### deleteElementLists

          void deleteElementLists()
                           throws TaurusCoreException

      Delete all li_....xml files belonging to the active application from the workspace.
      Throws:
        `TaurusCoreException` - if deleting the element list cache fails

    - #### notifyRefresh

          @Deprecated
          void notifyRefresh()

      Deprecated. does not refresh the tree view.
      Notifies observing views to refresh.

    - #### notifyObservers

          void notifyObservers(TaurusNotification pTaurusNotification)

      Triggers a notification event for all observers.
      Parameters:
        `pTaurusNotification` - the `TaurusNotification` that should be triggered.

    - #### getPreviousList

          IElementList getPreviousList(IElementList pEleList)

      Gets the element list which precedes the given element list.
      Parameters:
        `pEleList` - an element list
      Returns:
        the previous element list relative to the given list or `null` if there is none.

    - #### getNextList

          IElementList getNextList(IElementList pEleList)

      Gets the element list which follows the given element list.
      Parameters:
        `pEleList` - an element list
      Returns:
        the next element list relative to the given list or `null` if there is none.

    - #### getElementLists

          java.util.List<IElementList> getElementLists()

      Gets a list of all `IElementList`.
      Returns:
        a list of all element lists, which can be empty.

    - #### getElementLists

          java.util.List<IElementList> getElementLists(IResource pResource)

      Gets element lists which were created with the given resource.
      Parameters:
        `pResource` - the resource
      Returns:
        a list of element lists (can be empty)

    - #### showList

          void showList(IElementList pElementList,
                        java.lang.String pTableViewSecondaryId)

      Show the given element list in the table view with given secondary id.
      Parameters:
        `pElementList` - the element list to show
        `pTableViewSecondaryId` - the secondary id of the table view in which the list will be shown, if `null` the list will be shown in the main table view

    - #### addList

          void addList(IElementList pElementList,
                       java.lang.String pPrevListID,
                       java.lang.String pTableViewSecondaryId,
                       boolean pNotify)

      Add a new element list to the element list map and table view secondary id map and maintain the related internal data structures.
      Parameters:
        `pElementList` - element list to be added to the TAURUS element list directory and table view directory
        `pPrevListID` - element list which precedes this element list in the element list directory; maybe null, in this case the element list is added to the end of the element list directory
        `pTableViewSecondaryId` - secondary id of the table view in which the element list will be mapped, if `null`, the element list will be added to the main table view
        `pNotify` - whether the observer of this `class` will be notified

    - #### getList

          IElementList getList(IElementListKey pKey)

      Returns the element list for the given logical element list key.
      Parameters:
        `pKey` - logical element list key
      Returns:
        the element list with the given key or `null`, if the element list directory does not contain a list with the given key

Copyright © 2015 Micro Focus GmbH. All rights reserved.